/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.expression;

import engcalculator.expression.token.Token;
import java.util.LinkedList;

/**
 *
 * @author simone
 */
public class TokenList extends LinkedList <Token> {

    private int index = 0;
    private int lastUnderstoodTokenIndex=0;

    public Token get() {
        return get(index);
    }

    public boolean isInList () {
        return index >= 0 && index < size();
    }

    private void setLastUnderstoodToken () {
        Token t = get(index);
        try {
            if (t.getIntervalList() == null && "[](),_%;".indexOf(t.getSymbol()) == -1) lastUnderstoodTokenIndex = index;
        } catch (Exception ex) {
        }
    }

    public void nextToken () {
        if (! isInList()) return;
        setLastUnderstoodToken ();
        ++index;
    }

    public void previousToken () {
        if (! isInList()) return;
        setLastUnderstoodToken ();
        --index;
    }

    public void previousSubExpression () {
        thisSubExpression();
        previousToken();
        thisSubExpression();
    }

    public void thisSubExpression () {
        while (index > 0) {
            --index;
            if (";".equals(get(index).getTerminal())) {
                setLastUnderstoodToken ();
                ++index;
                break;
            }
        }
    }

    public void nextSubExpression () {
        while (index < size()) {
            if (";".equals(get(index).getTerminal())) {
                setLastUnderstoodToken ();
                ++index;
                break;
            }
            ++index;
        }
    }

    void goToEnd() {
        index = size()-1;
        setLastUnderstoodToken ();
        index = size();
    }

    public void reset () {
        index = 0;
    }

    @Override
    public String toString  () {
        StringBuffer result = new StringBuffer ();
        for (Token t : this)
            result.append(t.toString());
        result.append('\n');
        return result.toString();
    }

    String notUnderstoodToString() {
        StringBuffer result = new StringBuffer ();
        Token t;
        while ( lastUnderstoodTokenIndex < size()) {
            t = get(lastUnderstoodTokenIndex);
            ++lastUnderstoodTokenIndex;
            result.append(t.toString());
        }
        result.append('\n');
        return result.toString();
    }
}
