/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.infix.matrix;

import engcalculator.data.Interval;
import engcalculator.data.IntervalList;
import engcalculator.data.MatrixIntervalList;
import engcalculator.function.CalculusException;
import engcalculator.function.infix.InfixFunction;

/**
 *
 * @author simone
 */
public class GetVector extends InfixFunction {
    private final static String[] EXAMPLE_LEFT = {"(1,2,3,4)#2","(1,2,3,4)#2"};
    private final static String[] EXAMPLE_RIGHT = {"1_0","0_1"};
    private final static String[] RESULT = {"(2,4)#1", "(3,4)#2"};

    public GetVector() {
        super ("::", (byte) -1, (byte) 1, false, true, "Given a matrix the '::' is able to extract a row vector giving the input 0_row or a column with column_0.", EXAMPLE_LEFT, EXAMPLE_RIGHT, RESULT);
    }

    @Override
    public IntervalList _compute(IntervalList leftSide, IntervalList rightSide) throws Exception {
        IntervalList result = new IntervalList ();
        int column, row;
        Interval i;
        i = rightSide.getFirst();
        if (i.getLeft() == 0) {
            row = (int) i.getRight();
            for (column=0;column<leftSide.getColumns();++column) result.add(leftSide.get(row, column));
        } else if (i.getRight() == 0) {
            column = (int) i.getLeft();
            for (row=0;row<leftSide.getRows();++row) result.add(leftSide.get(row, column));
        } else throw new CalculusException ("Row or column should be 0") ;
        result = new MatrixIntervalList (result, leftSide.getColumns());
        return result;
    }

}
