/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.flowControl;

import engcalculator.data.FlowControl;
import engcalculator.data.Interval;
import engcalculator.data.Interval.WorkFlow;
import engcalculator.function.prefix.SingleInputSingleOutputPrefixFunction;
import engcalculator.function.infix.compare.NotEqual;

/**
 *
 * @author simone
 */
public class FlowControlPrefixFunction extends SingleInputSingleOutputPrefixFunction {
    private final static Interval FALSEINTERVAL = new Interval (0);
    private final static NotEqual NOTEQUAL = new NotEqual();
    
    private WorkFlow iftrue, iffalse;

    public FlowControlPrefixFunction(String name, String help, String[] examples, String[] results, WorkFlow iftrue, WorkFlow iffalse) {
        super(name, false, true, help+" This function is evaluated only if it is the last element of a list.", examples, results);
        this.iftrue = iftrue;
        this.iffalse = iffalse;
    }

    @Override
    public Interval _computeIntervals(Interval input) throws Exception {
        if (NOTEQUAL.compare(FALSEINTERVAL, input)) return new FlowControl(input, iftrue);
        return new FlowControl(input, iffalse);
    }



}
