/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.interval;

import engcalculator.data.Interval;
import engcalculator.function.prefix.SingleInputSingleOutputPrefixFunction;

/**
 *
 * @author simone
 */
public class Abs extends SingleInputSingleOutputPrefixFunction {
    private final static String[] EXAMPLE = {"-10_10","-10_-5","10_15","10_-10","-5_-10","15_10"};
    private final static String[] RESULT = {"0_10","5_10","10_15","10_0","10_5","15_10"};
    private final static Negate NEGATE = new Negate();
    public Abs() {
        super("abs", true, true, "Compute the abs of an interval. It is extended to directed interval and need to be verified for not proper interval.", EXAMPLE , RESULT);
    }
    
    @Override
    public Interval _computeIntervals (Interval input) throws Exception {
        if (input.isPositive()) return new Interval (input);
        if (input.isNegative()) return NEGATE._computeIntervals(input);
        if (input.isProper()) return new Interval (0, Math.max(input.getLeft(), input.getRight()));
        return new Interval (Math.max(input.getLeft(), input.getRight()), 0);
    }
}
