/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package engcalculator.function.prefix.space;


import engcalculator.data.Interval;
import engcalculator.data.IntervalList;
import engcalculator.function.CalculusException;
import engcalculator.function.prefix.PrefixFunction;

/**
 *
 * @author simone
 */
public abstract class Space extends PrefixFunction {

    public Space(String name, String function, String[] examples, String[] results) {
        super (name, (byte) 2, true,true,  name+" produces a list of intervals "+function+" spaced from the minimum to the maximum of the given interval. Syntax:"+name+" (number of points, interval). It is very useful to compute a function at several points.", examples, results);
    }


    @Override
    public final IntervalList _compute(IntervalList input) throws Exception {

        if (! input.getFirst().isInteger()) throw new CalculusException ("It was expected an integer for the number of intervals"+getSymbol());

        if (input.getFirst().getLeft() < 2) throw new CalculusException ("At least 2 intervals are required for "+getSymbol());

        double begin = __computeDirecte(input.get(1).getLeft());
        final double end = __computeDirecte(input.get(1).getRight());
        int noi = (int) input.getFirst().getLeft();

        -- noi;
        final double delta = (end-begin) / noi;

        IntervalList result = new IntervalList ();

        result.add(new Interval(__computeInverse(begin))); 

        -- noi;
        for (int i=0; i<noi; ++i)
            result.add(new Interval(__computeInverse(begin+=delta)));

        result.add(new Interval(__computeInverse(end)));

        return result;
    }

    protected abstract double __computeInverse (double input);

    protected abstract double __computeDirecte (double input);

}
